package org.xdoclet.plugin.tapestry.qtags;

public class ContribTreeTableDataViewTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.ContribTreeTableDataViewTag {
    public static final String NAME = "contrib.tree-table-data-view";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"tree-view",
		"node-view-component-address",
		"node-render-factory",
		"entries-per-table-page",
		"show-root-node",
		"table-colunms",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public ContribTreeTableDataViewTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public ContribTreeTableDataViewTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTreeView() {
		boolean required = false;
        String result = getNamedParameter("tree-view");
        if(required && result == null) {
            bomb("tree-view=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNodeViewComponentAddress() {
		boolean required = false;
        String result = getNamedParameter("node-view-component-address");
        if(required && result == null) {
            bomb("node-view-component-address=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNodeRenderFactory() {
		boolean required = false;
        String result = getNamedParameter("node-render-factory");
        if(required && result == null) {
            bomb("node-render-factory=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getEntriesPerTablePage() {
		boolean required = false;
        String result = getNamedParameter("entries-per-table-page");
        if(required && result == null) {
            bomb("entries-per-table-page=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getShowRootNode() {
		boolean required = false;
        String result = getNamedParameter("show-root-node");
        if(required && result == null) {
            bomb("show-root-node=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTableColunms() {
		boolean required = false;
        String result = getNamedParameter("table-colunms");
        if(required && result == null) {
            bomb("table-colunms=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getTreeView();
        getNodeViewComponentAddress();
        getNodeRenderFactory();
        getEntriesPerTablePage();
        getShowRootNode();
        getTableColunms();
    }

    public void validateModel() {
        // check uniqueness
    }
}