package org.xdoclet.plugin.tapestry.qtags;

public class TacosAjaxDirectLinkTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.TacosAjaxDirectLinkTag {
    public static final String NAME = "tacos.ajax-direct-link";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"update-components",
		"update-blocks",
		"update-object",
		"listener",
		"action",
		"parameters",
		"direct",
		"effects",
		"pre-effects",
		"status-element",
		"popup",
		"stateful",
		"disabled",
		"htmlid",
		"anchor",
		"renderer",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public TacosAjaxDirectLinkTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public TacosAjaxDirectLinkTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getUpdateComponents() {
		boolean required = false;
        String result = getNamedParameter("update-components");
        if(required && result == null) {
            bomb("update-components=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getUpdateBlocks() {
		boolean required = false;
        String result = getNamedParameter("update-blocks");
        if(required && result == null) {
            bomb("update-blocks=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getUpdateObject() {
		boolean required = false;
        String result = getNamedParameter("update-object");
        if(required && result == null) {
            bomb("update-object=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getListener() {
		boolean required = false;
        String result = getNamedParameter("listener");
        if(required && result == null) {
            bomb("listener=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAction() {
		boolean required = false;
        String result = getNamedParameter("action");
        if(required && result == null) {
            bomb("action=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getParameters_() {
		boolean required = false;
        String result = getNamedParameter("parameters");
        if(required && result == null) {
            bomb("parameters=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDirect() {
		boolean required = false;
        String result = getNamedParameter("direct");
        if(required && result == null) {
            bomb("direct=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getEffects() {
		boolean required = false;
        String result = getNamedParameter("effects");
        if(required && result == null) {
            bomb("effects=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPreEffects() {
		boolean required = false;
        String result = getNamedParameter("pre-effects");
        if(required && result == null) {
            bomb("pre-effects=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getStatusElement() {
		boolean required = false;
        String result = getNamedParameter("status-element");
        if(required && result == null) {
            bomb("status-element=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPopup() {
		boolean required = false;
        String result = getNamedParameter("popup");
        if(required && result == null) {
            bomb("popup=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getStateful() {
		boolean required = false;
        String result = getNamedParameter("stateful");
        if(required && result == null) {
            bomb("stateful=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisabled() {
		boolean required = false;
        String result = getNamedParameter("disabled");
        if(required && result == null) {
            bomb("disabled=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getHtmlid() {
		boolean required = false;
        String result = getNamedParameter("htmlid");
        if(required && result == null) {
            bomb("htmlid=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAnchor() {
		boolean required = false;
        String result = getNamedParameter("anchor");
        if(required && result == null) {
            bomb("anchor=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getRenderer() {
		boolean required = false;
        String result = getNamedParameter("renderer");
        if(required && result == null) {
            bomb("renderer=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getUpdateComponents();
        getUpdateBlocks();
        getUpdateObject();
        getListener();
        getAction();
        getParameters_();
        getDirect();
        getEffects();
        getPreEffects();
        getStatusElement();
        getPopup();
        getStateful();
        getDisabled();
        getHtmlid();
        getAnchor();
        getRenderer();
    }

    public void validateModel() {
        // check uniqueness
    }
}