package org.xdoclet.plugin.tapestry.qtags;

public class TacosAjaxFormTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.TacosAjaxFormTag {
    public static final String NAME = "tacos.ajax-form";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"update-components",
		"back-link",
		"forward-link",
		"update-object",
		"effects",
		"status-element",
		"method",
		"success",
		"cancel",
		"refresh",
		"listener",
		"stateful",
		"direct",
		"delegate",
		"client-validation-enabled",
		"focus",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public TacosAjaxFormTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public TacosAjaxFormTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getUpdateComponents() {
		boolean required = false;
        String result = getNamedParameter("update-components");
        if(required && result == null) {
            bomb("update-components=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getBackLink() {
		boolean required = false;
        String result = getNamedParameter("back-link");
        if(required && result == null) {
            bomb("back-link=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getForwardLink() {
		boolean required = false;
        String result = getNamedParameter("forward-link");
        if(required && result == null) {
            bomb("forward-link=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getUpdateObject() {
		boolean required = false;
        String result = getNamedParameter("update-object");
        if(required && result == null) {
            bomb("update-object=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getEffects() {
		boolean required = false;
        String result = getNamedParameter("effects");
        if(required && result == null) {
            bomb("effects=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getStatusElement() {
		boolean required = false;
        String result = getNamedParameter("status-element");
        if(required && result == null) {
            bomb("status-element=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMethod() {
		boolean required = false;
        String result = getNamedParameter("method");
        if(required && result == null) {
            bomb("method=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSuccess() {
		boolean required = false;
        String result = getNamedParameter("success");
        if(required && result == null) {
            bomb("success=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCancel() {
		boolean required = false;
        String result = getNamedParameter("cancel");
        if(required && result == null) {
            bomb("cancel=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getRefresh() {
		boolean required = false;
        String result = getNamedParameter("refresh");
        if(required && result == null) {
            bomb("refresh=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getListener() {
		boolean required = false;
        String result = getNamedParameter("listener");
        if(required && result == null) {
            bomb("listener=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getStateful() {
		boolean required = false;
        String result = getNamedParameter("stateful");
        if(required && result == null) {
            bomb("stateful=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDirect() {
		boolean required = false;
        String result = getNamedParameter("direct");
        if(required && result == null) {
            bomb("direct=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDelegate() {
		boolean required = false;
        String result = getNamedParameter("delegate");
        if(required && result == null) {
            bomb("delegate=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getClientValidationEnabled() {
		boolean required = false;
        String result = getNamedParameter("client-validation-enabled");
        if(required && result == null) {
            bomb("client-validation-enabled=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getFocus() {
		boolean required = false;
        String result = getNamedParameter("focus");
        if(required && result == null) {
            bomb("focus=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getUpdateComponents();
        getBackLink();
        getForwardLink();
        getUpdateObject();
        getEffects();
        getStatusElement();
        getMethod();
        getSuccess();
        getCancel();
        getRefresh();
        getListener();
        getStateful();
        getDirect();
        getDelegate();
        getClientValidationEnabled();
        getFocus();
    }

    public void validateModel() {
        // check uniqueness
    }
}