package org.xdoclet.plugin.tapestry.qtags;

public class ContribTreeTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.ContribTreeTag {
    public static final String NAME = "contrib.tree";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"tree-model",
		"tree-state-listener",
		"session-state-manager",
		"session-store-manager",
		"show-node-images",
		"make-node-direct",
		"node-render-factory",
		"show-root-node",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public ContribTreeTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public ContribTreeTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTreeModel() {
		boolean required = true;
        String result = getNamedParameter("tree-model");
        if(required && result == null) {
            bomb("tree-model=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTreeStateListener() {
		boolean required = false;
        String result = getNamedParameter("tree-state-listener");
        if(required && result == null) {
            bomb("tree-state-listener=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSessionStateManager() {
		boolean required = false;
        String result = getNamedParameter("session-state-manager");
        if(required && result == null) {
            bomb("session-state-manager=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSessionStoreManager() {
		boolean required = false;
        String result = getNamedParameter("session-store-manager");
        if(required && result == null) {
            bomb("session-store-manager=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getShowNodeImages() {
		boolean required = false;
        String result = getNamedParameter("show-node-images");
        if(required && result == null) {
            bomb("show-node-images=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMakeNodeDirect() {
		boolean required = false;
        String result = getNamedParameter("make-node-direct");
        if(required && result == null) {
            bomb("make-node-direct=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNodeRenderFactory() {
		boolean required = false;
        String result = getNamedParameter("node-render-factory");
        if(required && result == null) {
            bomb("node-render-factory=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getShowRootNode() {
		boolean required = false;
        String result = getNamedParameter("show-root-node");
        if(required && result == null) {
            bomb("show-root-node=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getTreeModel();
        getTreeStateListener();
        getSessionStateManager();
        getSessionStoreManager();
        getShowNodeImages();
        getMakeNodeDirect();
        getNodeRenderFactory();
        getShowRootNode();
    }

    public void validateModel() {
        // check uniqueness
    }
}