package org.xdoclet.plugin.tapestry.qtags;

public class TacosFisheyeListTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.tapestry.qtags.TacosFisheyeListTag {
    public static final String NAME = "tacos.fisheye-list";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"id",
		"item-width",
		"item-height",
		"item-max-width",
		"item-max-height",
		"orientation",
		"effect-units",
		"item-padding",
		"attach-edge",
		"label-edge",
		"break-on",
		"source",
		"value",
		"index",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public TacosFisheyeListTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public TacosFisheyeListTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getId() {
		boolean required = true;
        String result = getNamedParameter("id");
        if(required && result == null) {
            bomb("id=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getItemWidth() {
		boolean required = false;
        String result = getNamedParameter("item-width");
        if(required && result == null) {
            bomb("item-width=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getItemHeight() {
		boolean required = false;
        String result = getNamedParameter("item-height");
        if(required && result == null) {
            bomb("item-height=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getItemMaxWidth() {
		boolean required = false;
        String result = getNamedParameter("item-max-width");
        if(required && result == null) {
            bomb("item-max-width=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getItemMaxHeight() {
		boolean required = false;
        String result = getNamedParameter("item-max-height");
        if(required && result == null) {
            bomb("item-max-height=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getOrientation() {
		boolean required = false;
        String result = getNamedParameter("orientation");
        if(required && result == null) {
            bomb("orientation=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getEffectUnits() {
		boolean required = false;
        String result = getNamedParameter("effect-units");
        if(required && result == null) {
            bomb("effect-units=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getItemPadding() {
		boolean required = false;
        String result = getNamedParameter("item-padding");
        if(required && result == null) {
            bomb("item-padding=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAttachEdge() {
		boolean required = false;
        String result = getNamedParameter("attach-edge");
        if(required && result == null) {
            bomb("attach-edge=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLabelEdge() {
		boolean required = false;
        String result = getNamedParameter("label-edge");
        if(required && result == null) {
            bomb("label-edge=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getBreakOn() {
		boolean required = false;
        String result = getNamedParameter("break-on");
        if(required && result == null) {
            bomb("break-on=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSource() {
		boolean required = true;
        String result = getNamedParameter("source");
        if(required && result == null) {
            bomb("source=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getValue_() {
		boolean required = false;
        String result = getNamedParameter("value");
        if(required && result == null) {
            bomb("value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getIndex() {
		boolean required = false;
        String result = getNamedParameter("index");
        if(required && result == null) {
            bomb("index=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getId();
        getItemWidth();
        getItemHeight();
        getItemMaxWidth();
        getItemMaxHeight();
        getOrientation();
        getEffectUnits();
        getItemPadding();
        getAttachEdge();
        getLabelEdge();
        getBreakOn();
        getSource();
        getValue_();
        getIndex();
    }

    public void validateModel() {
        // check uniqueness
    }
}