package org.xdoclet.plugin.tapestry.qtags;

import org.generama.MetadataProvider;

public class TagLibrary {
    public static final String CONTRIB_CHECKBOX_GROUP = ContribCheckboxGroupTagImpl.NAME;
    public static final String CONTRIB_CHOOSE = ContribChooseTagImpl.NAME;
    public static final String CONTRIB_CONTROL_CHECKBOX = ContribControlCheckboxTagImpl.NAME;
    public static final String CONTRIB_CONTROLLED_CHECKBOX = ContribControlledCheckboxTagImpl.NAME;
    public static final String CONTRIB_DATE_FIELD = ContribDateFieldTagImpl.NAME;
    public static final String CONTRIB_DUMP_OBJECT = ContribDumpObjectTagImpl.NAME;
    public static final String CONTRIB_FORM_CONDITIONAL = ContribFormConditionalTagImpl.NAME;
    public static final String CONTRIB_FORM_TABLE = ContribFormTableTagImpl.NAME;
    public static final String CONTRIB_INSPECTOR_BUTTON = ContribInspectorButtonTagImpl.NAME;
    public static final String CONTRIB_MASK_EDIT = ContribMaskEditTagImpl.NAME;
    public static final String CONTRIB_MULTIPLE_PROPERTY_SELECTION = ContribMultiplePropertySelectionTagImpl.NAME;
    public static final String CONTRIB_NUMERIC_FIELD = ContribNumericFieldTagImpl.NAME;
    public static final String CONTRIB_OTHERWISE = ContribOtherwiseTagImpl.NAME;
    public static final String CONTRIB_PALETTE = ContribPaletteTagImpl.NAME;
    public static final String CONTRIB_SELECTOR = ContribSelectorTagImpl.NAME;
    public static final String CONTRIB_SHOW_DESCRIPTION = ContribShowDescriptionTagImpl.NAME;
    public static final String CONTRIB_SHOW_ENGINE = ContribShowEngineTagImpl.NAME;
    public static final String CONTRIB_SHOW_PROPERTIES = ContribShowPropertiesTagImpl.NAME;
    public static final String CONTRIB_SHOW_SPECIFICATION = ContribShowSpecificationTagImpl.NAME;
    public static final String CONTRIB_SHOW_TEMPLATE = ContribShowTemplateTagImpl.NAME;
    public static final String CONTRIB_SIMPLE_TABLE_COLUMN_COMPONENT = ContribSimpleTableColumnComponentTagImpl.NAME;
    public static final String CONTRIB_SIMPLE_TABLE_COLUMN_FORM_COMPONENT = ContribSimpleTableColumnFormComponentTagImpl.NAME;
    public static final String CONTRIB_TABLE_COLUMNS = ContribTableColumnsTagImpl.NAME;
    public static final String CONTRIB_TABLE_FORM_PAGES = ContribTableFormPagesTagImpl.NAME;
    public static final String CONTRIB_TABLE_FORM_ROWS = ContribTableFormRowsTagImpl.NAME;
    public static final String CONTRIB_TABLE_PAGES = ContribTablePagesTagImpl.NAME;
    public static final String CONTRIB_TABLE_ROWS = ContribTableRowsTagImpl.NAME;
    public static final String CONTRIB_TABLE = ContribTableTagImpl.NAME;
    public static final String CONTRIB_TABLE_VALUES = ContribTableValuesTagImpl.NAME;
    public static final String CONTRIB_TABLE_VIEW = ContribTableViewTagImpl.NAME;
    public static final String CONTRIB_TIMEOUT = ContribTimeoutTagImpl.NAME;
    public static final String CONTRIB_TREE_DATA_VIEW = ContribTreeDataViewTagImpl.NAME;
    public static final String CONTRIB_TREE_NODE_VIEW = ContribTreeNodeViewTagImpl.NAME;
    public static final String CONTRIB_TREE_TABLE_DATA_VIEW = ContribTreeTableDataViewTagImpl.NAME;
    public static final String CONTRIB_TREE_TABLE_NODE_VIEW_DELEGATOR = ContribTreeTableNodeViewDelegatorTagImpl.NAME;
    public static final String CONTRIB_TREE_TABLE = ContribTreeTableTagImpl.NAME;
    public static final String CONTRIB_TREE = ContribTreeTagImpl.NAME;
    public static final String CONTRIB_TREE_VIEW = ContribTreeViewTagImpl.NAME;
    public static final String CONTRIB_VALIDATING_TEXT_FIELD = ContribValidatingTextFieldTagImpl.NAME;
    public static final String CONTRIB_VIEW_TABS = ContribViewTabsTagImpl.NAME;
    public static final String CONTRIB_WHEN = ContribWhenTagImpl.NAME;
    public static final String CONTRIB_X_TILE = ContribXTileTagImpl.NAME;
    public static final String TACOS_AJAX_DIRECT_LINK = TacosAjaxDirectLinkTagImpl.NAME;
    public static final String TACOS_AJAX_FIELD_OBSERVER = TacosAjaxFieldObserverTagImpl.NAME;
    public static final String TACOS_AJAX_FORM = TacosAjaxFormTagImpl.NAME;
    public static final String TACOS_AJAX_LINK_SUBMIT = TacosAjaxLinkSubmitTagImpl.NAME;
    public static final String TACOS_AJAX_SUBMIT = TacosAjaxSubmitTagImpl.NAME;
    public static final String TACOS_AUTOCOMPLETER = TacosAutocompleterTagImpl.NAME;
    public static final String TACOS_DATE_PICKER = TacosDatePickerTagImpl.NAME;
    public static final String TACOS_DIALOG = TacosDialogTagImpl.NAME;
    public static final String TACOS_DIRTY_FORM_WARNING = TacosDirtyFormWarningTagImpl.NAME;
    public static final String TACOS_DROP_TARGET = TacosDropTargetTagImpl.NAME;
    public static final String TACOS_EDITOR = TacosEditorTagImpl.NAME;
    public static final String TACOS_FISHEYE_LIST = TacosFisheyeListTagImpl.NAME;
    public static final String TACOS_FLOATING_PANE = TacosFloatingPaneTagImpl.NAME;
    public static final String TACOS_INLINE_EDIT_BOX = TacosInlineEditBoxTagImpl.NAME;
    public static final String TACOS_PALETTE = TacosPaletteTagImpl.NAME;
    public static final String TACOS_PARTIAL_FOR = TacosPartialForTagImpl.NAME;
    public static final String TACOS_PROGRESS_BAR = TacosProgressBarTagImpl.NAME;
    public static final String TACOS_REFRESH = TacosRefreshTagImpl.NAME;
    public static final String TACOS_SITE_MAP = TacosSiteMapTagImpl.NAME;
    public static final String TACOS_TREE = TacosTreeTagImpl.NAME;
    public static final String TAPESTRY_ACTION_LINK = TapestryActionLinkTagImpl.NAME;
    public static final String TAPESTRY_ANY = TapestryAnyTagImpl.NAME;
    public static final String TAPESTRY_ASSET = TapestryAssetImpl.NAME;
    public static final String TAPESTRY_BEAN = TapestryBeanTagImpl.NAME;
    public static final String TAPESTRY_BINDING = TapestryBindingTagImpl.NAME;
    public static final String TAPESTRY_BLOCK = TapestryBlockTagImpl.NAME;
    public static final String TAPESTRY_BODY = TapestryBodyTagImpl.NAME;
    public static final String TAPESTRY_BUTTON = TapestryButtonTagImpl.NAME;
    public static final String TAPESTRY_CARD = TapestryCardTagImpl.NAME;
    public static final String TAPESTRY_CHECKBOX = TapestryCheckboxTagImpl.NAME;
    public static final String TAPESTRY_COMPONENT_SPECIFICATION = TapestryComponentSpecificationTagImpl.NAME;
    public static final String TAPESTRY_COMPONENT = TapestryComponentTagImpl.NAME;
    public static final String TAPESTRY_CONDITIONAL = TapestryConditionalTagImpl.NAME;
    public static final String TAPESTRY_DATE_PICKER = TapestryDatePickerTagImpl.NAME;
    public static final String TAPESTRY_DELEGATOR = TapestryDelegatorTagImpl.NAME;
    public static final String TAPESTRY_DESCRIBE = TapestryDescribeTagImpl.NAME;
    public static final String TAPESTRY_DIRECT_LINK = TapestryDirectLinkTagImpl.NAME;
    public static final String TAPESTRY_DO = TapestryDoTagImpl.NAME;
    public static final String TAPESTRY_ELSE = TapestryElseTagImpl.NAME;
    public static final String TAPESTRY_EXCEPTION_DISPLAY = TapestryExceptionDisplayTagImpl.NAME;
    public static final String TAPESTRY_EXTERNAL_LINK = TapestryExternalLinkTagImpl.NAME;
    public static final String TAPESTRY_FIELD_LABEL = TapestryFieldLabelTagImpl.NAME;
    public static final String TAPESTRY_FOR = TapestryForTagImpl.NAME;
    public static final String TAPESTRY_FOREACH = TapestryForeachTagImpl.NAME;
    public static final String TAPESTRY_FORM = TapestryFormTagImpl.NAME;
    public static final String TAPESTRY_FRAME = TapestryFrameTagImpl.NAME;
    public static final String TAPESTRY_GENERIC_LINK = TapestryGenericLinkTagImpl.NAME;
    public static final String TAPESTRY_GO = TapestryGoTagImpl.NAME;
    public static final String TAPESTRY_HIDDEN = TapestryHiddenTagImpl.NAME;
    public static final String TAPESTRY_IF = TapestryIfImpl.NAME;
    public static final String TAPESTRY_IMAGE_SUBMIT = TapestryImageSubmitTagImpl.NAME;
    public static final String TAPESTRY_IMAGE = TapestryImageTagImpl.NAME;
    public static final String TAPESTRY_INJECT_META = TapestryInjectMetaTagImpl.NAME;
    public static final String TAPESTRY_INJECT_OBJECT = TapestryInjectObjectTagImpl.NAME;
    public static final String TAPESTRY_INJECT_PAGE = TapestryInjectPageTagImpl.NAME;
    public static final String TAPESTRY_INJECT_SCRIPT = TapestryInjectScriptTagImpl.NAME;
    public static final String TAPESTRY_INJECT_STATE = TapestryInjectStateTagImpl.NAME;
    public static final String TAPESTRY_INJECT = TapestryInjectTagImpl.NAME;
    public static final String TAPESTRY_INPUT = TapestryInputTagImpl.NAME;
    public static final String TAPESTRY_INSERT = TapestryInsertTagImpl.NAME;
    public static final String TAPESTRY_INSERT_TEXT = TapestryInsertTextTagImpl.NAME;
    public static final String TAPESTRY_INVOKE_LISTENER = TapestryInvokeListenerTagImpl.NAME;
    public static final String TAPESTRY_LINK_SUBMIT = TapestryLinkSubmitTagImpl.NAME;
    public static final String TAPESTRY_LIST_EDIT = TapestryListEditTagImpl.NAME;
    public static final String TAPESTRY_META = TapestryMetaTagImpl.NAME;
    public static final String TAPESTRY_ON_EVENT = TapestryOnEventTagImpl.NAME;
    public static final String TAPESTRY_OPTION = TapestryOptionTagImpl.NAME;
    public static final String TAPESTRY_PAGE_LINK = TapestryPageLinkTagImpl.NAME;
    public static final String TAPESTRY_PAGE_SPECIFICATION = TapestryPageSpecificationTagImpl.NAME;
    public static final String TAPESTRY_PARAMETER = TapestryParameterTagImpl.NAME;
    public static final String TAPESTRY_POSTFIELD = TapestryPostfieldTagImpl.NAME;
    public static final String TAPESTRY_PROPERTY_SELECTION = TapestryPropertySelectionTagImpl.NAME;
    public static final String TAPESTRY_PROPERTY = TapestryPropertyTagImpl.NAME;
    public static final String TAPESTRY_RADIO_GROUP = TapestryRadioGroupTagImpl.NAME;
    public static final String TAPESTRY_RADIO = TapestryRadioTagImpl.NAME;
    public static final String TAPESTRY_RENDER_BLOCK = TapestryRenderBlockTagImpl.NAME;
    public static final String TAPESTRY_RENDER_BODY = TapestryRenderBodyTagImpl.NAME;
    public static final String TAPESTRY_REQUEST_DISPLAY = TapestryRequestDisplayTagImpl.NAME;
    public static final String TAPESTRY_RESERVED_PARAMETER = TapestryReservedParameterTagImpl.NAME;
    public static final String TAPESTRY_ROLLOVER = TapestryRolloverTagImpl.NAME;
    public static final String TAPESTRY_SCRIPT = TapestryScriptTagImpl.NAME;
    public static final String TAPESTRY_SELECT = TapestrySelectTagImpl.NAME;
    public static final String TAPESTRY_SELECTION_FIELD = TapestrySelectionFieldTagImpl.NAME;
    public static final String TAPESTRY_SERVICE_LINK = TapestryServiceLinkTagImpl.NAME;
    public static final String TAPESTRY_SET = TapestrySetTagImpl.NAME;
    public static final String TAPESTRY_SETVAR = TapestrySetvarTagImpl.NAME;
    public static final String TAPESTRY_SHELL = TapestryShellTagImpl.NAME;
    public static final String TAPESTRY_SUBMIT = TapestrySubmitTagImpl.NAME;
    public static final String TAPESTRY_TEXT_AREA = TapestryTextAreaTagImpl.NAME;
    public static final String TAPESTRY_TEXT_FIELD = TapestryTextFieldTagImpl.NAME;
    public static final String TAPESTRY_TIMER = TapestryTimerTagImpl.NAME;
    public static final String TAPESTRY_UPLOAD = TapestryUploadTagImpl.NAME;
    public static final String TAPESTRY_VALID_FIELD = TapestryValidFieldTagImpl.NAME;

    public TagLibrary(MetadataProvider metadataProvider) {
        metadataProvider.getDocletTagFactory().registerTag(ContribCheckboxGroupTagImpl.NAME, ContribCheckboxGroupTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribChooseTagImpl.NAME, ContribChooseTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribControlCheckboxTagImpl.NAME, ContribControlCheckboxTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribControlledCheckboxTagImpl.NAME, ContribControlledCheckboxTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribDateFieldTagImpl.NAME, ContribDateFieldTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribDumpObjectTagImpl.NAME, ContribDumpObjectTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribFormConditionalTagImpl.NAME, ContribFormConditionalTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribFormTableTagImpl.NAME, ContribFormTableTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribInspectorButtonTagImpl.NAME, ContribInspectorButtonTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribMaskEditTagImpl.NAME, ContribMaskEditTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribMultiplePropertySelectionTagImpl.NAME, ContribMultiplePropertySelectionTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribNumericFieldTagImpl.NAME, ContribNumericFieldTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribOtherwiseTagImpl.NAME, ContribOtherwiseTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribPaletteTagImpl.NAME, ContribPaletteTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribSelectorTagImpl.NAME, ContribSelectorTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribShowDescriptionTagImpl.NAME, ContribShowDescriptionTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribShowEngineTagImpl.NAME, ContribShowEngineTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribShowPropertiesTagImpl.NAME, ContribShowPropertiesTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribShowSpecificationTagImpl.NAME, ContribShowSpecificationTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribShowTemplateTagImpl.NAME, ContribShowTemplateTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribSimpleTableColumnComponentTagImpl.NAME, ContribSimpleTableColumnComponentTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribSimpleTableColumnFormComponentTagImpl.NAME, ContribSimpleTableColumnFormComponentTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTableColumnsTagImpl.NAME, ContribTableColumnsTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTableFormPagesTagImpl.NAME, ContribTableFormPagesTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTableFormRowsTagImpl.NAME, ContribTableFormRowsTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTablePagesTagImpl.NAME, ContribTablePagesTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTableRowsTagImpl.NAME, ContribTableRowsTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTableTagImpl.NAME, ContribTableTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTableValuesTagImpl.NAME, ContribTableValuesTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTableViewTagImpl.NAME, ContribTableViewTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTimeoutTagImpl.NAME, ContribTimeoutTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTreeDataViewTagImpl.NAME, ContribTreeDataViewTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTreeNodeViewTagImpl.NAME, ContribTreeNodeViewTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTreeTableDataViewTagImpl.NAME, ContribTreeTableDataViewTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTreeTableNodeViewDelegatorTagImpl.NAME, ContribTreeTableNodeViewDelegatorTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTreeTableTagImpl.NAME, ContribTreeTableTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTreeTagImpl.NAME, ContribTreeTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribTreeViewTagImpl.NAME, ContribTreeViewTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribValidatingTextFieldTagImpl.NAME, ContribValidatingTextFieldTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribViewTabsTagImpl.NAME, ContribViewTabsTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribWhenTagImpl.NAME, ContribWhenTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(ContribXTileTagImpl.NAME, ContribXTileTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosAjaxDirectLinkTagImpl.NAME, TacosAjaxDirectLinkTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosAjaxFieldObserverTagImpl.NAME, TacosAjaxFieldObserverTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosAjaxFormTagImpl.NAME, TacosAjaxFormTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosAjaxLinkSubmitTagImpl.NAME, TacosAjaxLinkSubmitTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosAjaxSubmitTagImpl.NAME, TacosAjaxSubmitTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosAutocompleterTagImpl.NAME, TacosAutocompleterTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosDatePickerTagImpl.NAME, TacosDatePickerTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosDialogTagImpl.NAME, TacosDialogTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosDirtyFormWarningTagImpl.NAME, TacosDirtyFormWarningTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosDropTargetTagImpl.NAME, TacosDropTargetTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosEditorTagImpl.NAME, TacosEditorTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosFisheyeListTagImpl.NAME, TacosFisheyeListTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosFloatingPaneTagImpl.NAME, TacosFloatingPaneTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosInlineEditBoxTagImpl.NAME, TacosInlineEditBoxTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosPaletteTagImpl.NAME, TacosPaletteTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosPartialForTagImpl.NAME, TacosPartialForTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosProgressBarTagImpl.NAME, TacosProgressBarTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosRefreshTagImpl.NAME, TacosRefreshTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosSiteMapTagImpl.NAME, TacosSiteMapTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TacosTreeTagImpl.NAME, TacosTreeTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryActionLinkTagImpl.NAME, TapestryActionLinkTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryAnyTagImpl.NAME, TapestryAnyTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryAssetImpl.NAME, TapestryAssetImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryBeanTagImpl.NAME, TapestryBeanTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryBindingTagImpl.NAME, TapestryBindingTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryBlockTagImpl.NAME, TapestryBlockTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryBodyTagImpl.NAME, TapestryBodyTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryButtonTagImpl.NAME, TapestryButtonTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryCardTagImpl.NAME, TapestryCardTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryCheckboxTagImpl.NAME, TapestryCheckboxTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryComponentSpecificationTagImpl.NAME, TapestryComponentSpecificationTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryComponentTagImpl.NAME, TapestryComponentTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryConditionalTagImpl.NAME, TapestryConditionalTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryDatePickerTagImpl.NAME, TapestryDatePickerTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryDelegatorTagImpl.NAME, TapestryDelegatorTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryDescribeTagImpl.NAME, TapestryDescribeTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryDirectLinkTagImpl.NAME, TapestryDirectLinkTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryDoTagImpl.NAME, TapestryDoTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryElseTagImpl.NAME, TapestryElseTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryExceptionDisplayTagImpl.NAME, TapestryExceptionDisplayTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryExternalLinkTagImpl.NAME, TapestryExternalLinkTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryFieldLabelTagImpl.NAME, TapestryFieldLabelTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryForTagImpl.NAME, TapestryForTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryForeachTagImpl.NAME, TapestryForeachTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryFormTagImpl.NAME, TapestryFormTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryFrameTagImpl.NAME, TapestryFrameTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryGenericLinkTagImpl.NAME, TapestryGenericLinkTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryGoTagImpl.NAME, TapestryGoTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryHiddenTagImpl.NAME, TapestryHiddenTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryIfImpl.NAME, TapestryIfImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryImageSubmitTagImpl.NAME, TapestryImageSubmitTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryImageTagImpl.NAME, TapestryImageTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryInjectMetaTagImpl.NAME, TapestryInjectMetaTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryInjectObjectTagImpl.NAME, TapestryInjectObjectTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryInjectPageTagImpl.NAME, TapestryInjectPageTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryInjectScriptTagImpl.NAME, TapestryInjectScriptTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryInjectStateTagImpl.NAME, TapestryInjectStateTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryInjectTagImpl.NAME, TapestryInjectTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryInputTagImpl.NAME, TapestryInputTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryInsertTagImpl.NAME, TapestryInsertTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryInsertTextTagImpl.NAME, TapestryInsertTextTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryInvokeListenerTagImpl.NAME, TapestryInvokeListenerTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryLinkSubmitTagImpl.NAME, TapestryLinkSubmitTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryListEditTagImpl.NAME, TapestryListEditTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryMetaTagImpl.NAME, TapestryMetaTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryOnEventTagImpl.NAME, TapestryOnEventTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryOptionTagImpl.NAME, TapestryOptionTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryPageLinkTagImpl.NAME, TapestryPageLinkTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryPageSpecificationTagImpl.NAME, TapestryPageSpecificationTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryParameterTagImpl.NAME, TapestryParameterTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryPostfieldTagImpl.NAME, TapestryPostfieldTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryPropertySelectionTagImpl.NAME, TapestryPropertySelectionTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryPropertyTagImpl.NAME, TapestryPropertyTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryRadioGroupTagImpl.NAME, TapestryRadioGroupTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryRadioTagImpl.NAME, TapestryRadioTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryRenderBlockTagImpl.NAME, TapestryRenderBlockTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryRenderBodyTagImpl.NAME, TapestryRenderBodyTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryRequestDisplayTagImpl.NAME, TapestryRequestDisplayTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryReservedParameterTagImpl.NAME, TapestryReservedParameterTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryRolloverTagImpl.NAME, TapestryRolloverTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryScriptTagImpl.NAME, TapestryScriptTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestrySelectTagImpl.NAME, TapestrySelectTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestrySelectionFieldTagImpl.NAME, TapestrySelectionFieldTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryServiceLinkTagImpl.NAME, TapestryServiceLinkTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestrySetTagImpl.NAME, TapestrySetTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestrySetvarTagImpl.NAME, TapestrySetvarTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryShellTagImpl.NAME, TapestryShellTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestrySubmitTagImpl.NAME, TapestrySubmitTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryTextAreaTagImpl.NAME, TapestryTextAreaTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryTextFieldTagImpl.NAME, TapestryTextFieldTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryTimerTagImpl.NAME, TapestryTimerTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryUploadTagImpl.NAME, TapestryUploadTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(TapestryValidFieldTagImpl.NAME, TapestryValidFieldTagImpl.class);
    }
}
